//+----------------------------------------------------------------------------+
//|                                                     test_OpenPosition.mq4  |
//|                                                                            |
//|                                                      . aka KimIV  |
//|                                                       http://www.kimiv.ru  |
//|                                                                            |
//|  17.03.2008      OpenPosition().               |
//+----------------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link  "http://www.kimiv.ru"
#property show_confirm

//-------   -----------------------------------------------+
bool   gbDisabled    = False;          //   
color  clOpenBuy     = LightBlue;      //    
color  clOpenSell    = LightCoral;     //    
color  clModifyBuy   = Aqua;           //    
color  clModifySell  = Tomato;         //    
bool   MarketWatch   = False;          //    "Market Watch".
int    Slippage      = 3;              //  
int    modeSetOrders = 1;              //   :
                                       //  0 -   
                                       //  1 -  
                                       //  2 -    
int    NumberOfTry   = 2;              //   
bool   UseSound      = True;           //   
string SoundSuccess  = "ok.wav";       //  
string SoundError    = "timeout.wav";  //  

//-------    -----------------------------------------+
#include <stdlib.mqh>                  //  


void start() {
  double pa, pb, po;
  string sy;

//1.  0.1   
//  OpenPosition(NULL, OP_BUY, 0.1);

//2.  0.2  EURUSD
//  sy="EURUSD";
//  pa=MarketInfo("EURUSD", MODE_ASK);
//  pb=MarketInfo("EURUSD", MODE_BID);
//  po=MarketInfo("EURUSD", MODE_POINT);
//  OpenPosition(sy, OP_SELL, 0.2);

//3.  0.12  USDCAD   20 
//  sy="USDCAD";
//  pa=MarketInfo("USDCAD", MODE_ASK);
//  pb=MarketInfo("USDCAD", MODE_BID);
//  po=MarketInfo("USDCAD", MODE_POINT);
//  OpenPosition("USDCAD", OP_SELL, 0.12, pb+20*po);

//4.  0.15  USDJPY   40 
//  sy="USDJPY";
//  pa=MarketInfo("USDJPY", MODE_ASK);
//  pb=MarketInfo("USDJPY", MODE_BID);
//  po=MarketInfo("USDJPY", MODE_POINT);
//  OpenPosition("USDJPY", OP_BUY, 0.15, 0, pa+40*po);

//5.  0.1  GBPJPY   23   44 
//  sy="GBPJPY";
//  pa=MarketInfo("GBPJPY", MODE_ASK);
//  pb=MarketInfo("GBPJPY", MODE_BID);
//  po=MarketInfo("GBPJPY", MODE_POINT);
//  OpenPosition("GBPJPY", OP_SELL, 0.1, pb+23*po, pb-44*po);

//6.  0.01  EURUSD   2
  sy="EURUSD";
  pa=MarketInfo("EURUSD", MODE_ASK);
  pb=MarketInfo("EURUSD", MODE_BID);
  po=MarketInfo("EURUSD", MODE_POINT);
  OpenPosition("EURUSD", OP_SELL, 0.01, pb+2*po);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 06.03.2008                                                     |
//|   :                              |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//|    ot -               ( 0   -   )           |
//+----------------------------------------------------------------------------+
bool ExistPositions(string sy="", int op=-1, int mn=-1, datetime ot=0) {
  int i, k=OrdersTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sy || sy=="") {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              if (ot<=OrderOpenTime()) return(True);
            }
          }
        }
      }
    }
  }
  return(False);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                          |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    op -                                       |
//+----------------------------------------------------------------------------+
string GetNameOP(int op) {
  switch (op) {
    case OP_BUY      : return("Buy");
    case OP_SELL     : return("Sell");
    case OP_BUYLIMIT : return("Buy Limit");
    case OP_SELLLIMIT: return("Sell Limit");
    case OP_BUYSTOP  : return("Buy Stop");
    case OP_SELLSTOP : return("Sell Stop");
    default          : return("Unknown Operation");
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                                |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    TimeFrame -  ( )      (0 -  )         |
//+----------------------------------------------------------------------------+
string GetNameTF(int TimeFrame=0) {
  if (TimeFrame==0) TimeFrame=Period();
  switch (TimeFrame) {
    case PERIOD_M1:  return("M1");
    case PERIOD_M5:  return("M5");
    case PERIOD_M15: return("M15");
    case PERIOD_M30: return("M30");
    case PERIOD_H1:  return("H1");
    case PERIOD_H4:  return("H4");
    case PERIOD_D1:  return("Daily");
    case PERIOD_W1:  return("Weekly");
    case PERIOD_MN1: return("Monthly");
    default:		     return("UnknownPeriod");
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 18.07.2008                                                     |
//|   :        .      |
//+----------------------------------------------------------------------------+
color IIFc(bool condition, color ifTrue, color ifFalse) {
  if (condition) return(ifTrue); else return(ifFalse);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                                  |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    m -                                                       |
//+----------------------------------------------------------------------------+
void Message(string m) {
  Comment(m);
  if (StringLen(m)>0) Print(m);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 08.03.2013                                                     |
//|   :     .           |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    pp -                                                 |
//|    sl -                                                 |
//|    tp -                                                 |
//|    ex -                                                       |
//+----------------------------------------------------------------------------+
void ModifyOrder(double pp=-1, double sl=0, double tp=0, datetime ex=0) {
  bool   fm;
  color  cl=IIFc(OrderType()==OP_BUY
              || OrderType()==OP_BUYLIMIT
              || OrderType()==OP_BUYSTOP, clModifyBuy, clModifySell);
  double di, op, pa, pb, os, ot;
  int    dg=MarketInfo(OrderSymbol(), MODE_DIGITS), er, it;

  if (pp<=0) pp=OrderOpenPrice();
  if (sl<0 ) sl=OrderStopLoss();
  if (tp<0 ) tp=OrderTakeProfit();
  
  pp=NormalizeDouble(pp, dg);
  sl=NormalizeDouble(sl, dg);
  tp=NormalizeDouble(tp, dg);
  op=NormalizeDouble(OrderOpenPrice() , dg);
  os=NormalizeDouble(OrderStopLoss()  , dg);
  ot=NormalizeDouble(OrderTakeProfit(), dg);

  if (pp!=op || sl!=os || tp!=ot) {
    for (it=1; it<=NumberOfTry; it++) {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      fm=OrderModify(OrderTicket(), pp, sl, tp, ex, cl);
      if (fm) {
        if (UseSound) PlaySound(SoundSuccess); break;
      } else {
        er=GetLastError();
        if (UseSound) PlaySound(SoundError);
        di=MarketInfo(OrderSymbol(), MODE_DIGITS);
        pa=MarketInfo(OrderSymbol(), MODE_ASK);
        pb=MarketInfo(OrderSymbol(), MODE_BID);
        Message("Error("+er+") modifying order: "+ErrorDescription(er)+", try "+it+"\n"
          +"Ask="+DoubleToStr(pa,di)+"  Bid="+DoubleToStr(pb,di)+"  sy="+OrderSymbol()
          +"  op="+GetNameOP(OrderType())+"  pp="+DoubleToStr(pp,di)
          +"  sl="+DoubleToStr(sl,di)+"  tp="+DoubleToStr(tp,di));
        Sleep(1000*10);
      }
    }
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 25.03.2013                                                     |
//|   :     .                            |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (NULL  "" -  )          |
//|    op -                                                            |
//|    ll -                                                                 |
//|    sl -                                                         |
//|    tp -                                                         |
//|    mn - MagicNumber                                                        |
//|    co -                                                         |
//+----------------------------------------------------------------------------+
void OpenPosition(string sy, int op, double ll, double sl=0, double tp=0, int mn=0, string co="") {
  color    clOpen;
  datetime ot;
  double   mp, pp, pa, pb;
  int      di, err, it, ticket, msl;

  if (sy=="" || sy=="0") sy=Symbol();
  msl=MarketInfo(sy, MODE_STOPLEVEL)+MarketInfo(sy, MODE_SPREAD);
  if (op==OP_BUY) clOpen=clOpenBuy; else clOpen=clOpenSell;
  if (co=="") co=WindowExpertName()+" "+GetNameTF(Period());
  for (it=1; it<=NumberOfTry; it++) {
    if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) {
      Message("OpenPosition():   ");
      break;
    }
    while (!IsTradeAllowed()) Sleep(5000);
    RefreshRates();
    di=MarketInfo(sy, MODE_DIGITS);
    mp=MarketInfo(sy, MODE_POINT);
    pa=MarketInfo(sy, MODE_ASK);
    pb=MarketInfo(sy, MODE_BID);
    if (op==OP_BUY) pp=pa; else pp=pb;
    pp=NormalizeDouble(pp, di);
    ot=TimeCurrent();
    if (MarketWatch)
      ticket=OrderSend(sy, op, ll, pp, Slippage, 0, 0, co, mn, 0, clOpen);
    else
      ticket=OrderSend(sy, op, ll, pp, Slippage, sl, tp, co, mn, 0, clOpen);
    if (ticket>0) {
      if (UseSound) PlaySound(SoundSuccess); break;
    } else {
      err=GetLastError();
      if (UseSound) PlaySound(SoundError);
      if (pa==0 && pb==0) Message("      "+sy);
      //    
      Message("Error("+err+") opening position: "+ErrorDescription(err)+", try "+it+"  \n"
        +"Ask="+DoubleToStr(pa,di)+"  Bid="+DoubleToStr(pb,di)+"  sy="+sy+"  ll="+DoubleToStr(ll,2)+"  op="+GetNameOP(op)+"  \n"
        +"pp="+DoubleToStr(pp,di)+"  sl="+DoubleToStr(sl,di)+"  tp="+DoubleToStr(tp,di)+"  mn="+mn);
      //  
      if (err==130) {
        //   
        if (modeSetOrders==1) {
          Sleep(1000*5.3);
          switch (op) {
            case OP_BUY:
              if (sl>pp-msl*mp) sl=pp-msl*mp;
              if (tp>0 && tp<pp+msl*mp) tp=pp+msl*mp;
              break;
            case OP_SELL:
              if (sl>0 && sl<pp+msl*mp) sl=pp+msl*mp;
              if (tp>pp-msl*mp) tp=pp-msl*mp;
              break;
          }
          Message("OpenPosition():     \n"
            +"Ask="+DoubleToStr(pa,di)+"  Bid="+DoubleToStr(pb,di)+"  sy="+sy+"  ll="+DoubleToStr(ll,2)+"  op="+GetNameOP(op)+"  \n"
            +"pp="+DoubleToStr(pp,di)+"  sl="+DoubleToStr(sl,di)+"  tp="+DoubleToStr(tp,di)+"  mn="+mn);
          continue;
        }
      }
      //   
      if (err==2 || err==64 || err==65 || err==133) {
        gbDisabled=True; break;
      }
      //  
      if (err==4 || err==131 || err==132) {
        Sleep(1000*300); break;
      }
      if (err==128 || err==142 || err==143) {
        Sleep(1000*66.666);
        if (ExistPositions(sy, op, mn, ot)) {
          if (UseSound) PlaySound(SoundSuccess); break;
        }
      }
      if (err==140 || err==148 || err==4110 || err==4111) break;
      if (err==141) Sleep(1000*100);
      if (err==145) Sleep(1000*17);
      if (err==146) while (IsTradeContextBusy()) Sleep(1000*11);
      if (err!=135 && err!=138) Sleep(1000*7.7);
    }
  }
  if (MarketWatch && ticket>0 && (sl>0 || tp>0)) {
    if (OrderSelect(ticket, SELECT_BY_TICKET)) ModifyOrder(-1, sl, tp);
  }
}
//+----------------------------------------------------------------------------+

